## Colonize the Moon Mod Project
## Changes copyright Shin 2005
## (if any portion of this copyright should be found to be void, the remainder shall remain in full effect)
##
## GameEvents
#
# --Shin
# (aka. Belizan)

from CvPythonExtensions import *
from types import *
import PlayerUtils

gc = CyGlobalContext()

#PlayerUtils.setPlayerDictionaryValue(pPlayer, "notificationQueue", [])
#PlayerUtils.setPlayerDictionaryValue(pPlayer, "gameEvents", {})


def prepNotificationQueue(pPlayer):
    PlayerUtils.setPlayerDictionaryValue(pPlayer, "notificationQueue", [])


def handleEvents(pPlayer, bBeginningOfTurn):
    " Process events for this phase of this player's turn "
                        
    iGameTurn = gc.getGame().getGameTurn()
    
    #message = "In handle events for turn %d(%s)" %(iGameTurn, str(bBeginningOfTurn))
    #CyInterface().addMessage(pPlayer.getID(),True,len(message),message,'AS2D_BOMBARDED',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(7),0,0,True,True)
    
    if(bBeginningOfTurn):
        sKey = str(iGameTurn) + "B"
    else:
        sKey = str(iGameTurn) + "E"
        
    #message = "Key: %s" %(sKey)
    #CyInterface().addMessage(pPlayer.getID(),True,len(message),message,'AS2D_BOMBARDED',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(7),0,0,True,True)
    
    dEvents = PlayerUtils.getPlayerDictionaryValue(pPlayer, "gameEvents")
    #message = "Events: %s" %(str(dEvents))
    #CyInterface().addMessage(pPlayer.getID(),True,len(message),message,'AS2D_BOMBARDED',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(7),0,0,True,True)
    
    if(dEvents == -1):
        #message = "No event queue for player: %s" %(pPlayer.getName())
        #CyInterface().addMessage(0,True,len(message),message,'AS2D_BOMBARDED',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(7),0,0,True,True)
        return
        
    if(dEvents.has_key(sKey)):
        lEvents = dEvents[sKey]
    else:
        return
    
    for i in range(len(lEvents)):
        pEvent = lEvents[i]
        pEvent.processEvent(pPlayer)

        
def addEvent(eventInitialTurn, pEvent):
    " Add an event to the pPlayer's long term event queue "
    for i in range(len(pEvent.getPlayerSet())):
        iPlayer = pEvent.getPlayerSet()[i]
        pPlayer = gc.getPlayer(iPlayer)
        dEvents = PlayerUtils.getPlayerDictionaryValue(pPlayer, "gameEvents")
        if(dEvents == -1):
            dEvents = {}
        if(dEvents.has_key(eventInitialTurn)):
            dEvents[eventInitialTurn].append(pEvent)
        else:
            dEvents[eventInitialTurn] = [pEvent]
        PlayerUtils.setPlayerDictionaryValue(pPlayer, "gameEvents", dEvents)
    

# Note: Notification queues are only valid during the begin player turn process.  If an event
#  wishes to make a notification, it needs to put an event into the event queue for that player
#  adding the notification to the queue at the beginning of the turn.
def addNotification(pPlayer, pNotification):
    " Add a notification to the notification queue of the specified player "
    lQueue = PlayerUtils.getPlayerDictionaryValue(pPlayer, "notificationQueue")
    lQueue.append(pNotification)
    PlayerUtils.setPlayerDictionaryValue(pPlayer, "notificationQueue", lQueue)
    
def startNotifications(pPlayer):
    lQueue = PlayerUtils.getPlayerDictionaryValue(pPlayer, "notificationQueue")
    if(lQueue == -1):
        lQueue = []
        
    if(len(lQueue) > 0):
        pNotification = lQueue[0]
        pNotification.notify(pPlayer, 1)
        
                
#initialSatScan = GameEvents.GameEvent((i), (Satellites.Image, pPlayer.getStartingPlot().getX(), pPlayer.getStartingPlot().getY(), 5))
class GameEvent:
    def __init__(self, playerSet, eventData):
        ' Initialize an event '
        self.PlayerSet = playerSet
        self.EventData = eventData
        
    def getPlayerSet(self):
        return self.PlayerSet
        
    def processEvent(self, pPlayer):
        self.EventData[0](pPlayer, self.EventData)
        

# A game event which adds a notification.
class NotificationGameEvent(GameEvent):
    def __init__(self, playerSet, eventData):
        ' Initizalize base class '
        self.parent = GameEvent
        self.parent.__init__(self, playerSet, eventData)
        
    def processEvent(self, pPlayer):
        addNotification(eventData[0])
        
        

# Notifications are queued, and therein, chained
class Notification:
    def __init__(self, notificationData):
        ' Initialize a notification event '
        self.NotificationData = notificationData
    
    def notify(self, pPlayer, nextNotification):
        lQueue = PlayerUtils.getPlayerDictionaryValue(pPlayer, "notificationQueue")
        if(len(lQueue) > nextNotification):
            pNotification = lQueue[nextNotification]
            pNotification.notify(pPlayer, nextNotification+1)


class GenericNotification(Notification):
    def __init__(self, notificationData):
        ' Initilize base class '
        self.parent = Notification
        self.parent.__init__(self, notificationData)
    
    # This is wrong
    def notify(self, pPlayer, nextNotification):
        notificationData[0](notificationData)
        
        self.parent.notify(self, pPlayer, nextEvent)