## Colonize the Moon Mod Project
## Changes copyright Shin 2005
## (if any portion of this copyright should be found to be void, the remainder shall remain in full effect)
##
## Satellites
#
# --Shin
# (aka. Belizan)

from CvPythonExtensions import *
from types import *
import GameEvents
import Popup as PyPopup

gc = CyGlobalContext()



def StartingImage(pPlayer, argsList):
    self, iX, iY, iRadius = argsList
    iTeam = pPlayer.getTeam()
    
    for x in range (-iRadius, iRadius+1):
        for y in range (-iRadius, iRadius+1):
            pPlot = gc.getMap().plot(iX+x, iY+y)
            if(not pPlot.isNone()):
                pPlot.setRevealed(iTeam, True, True, iTeam)
    
    if(pPlayer.isAlive() and pPlayer.isHuman()):
        popupInfo = CyPopupInfo()
        popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON_SCREEN)
        popupInfo.setText(u"showInitialSatScan")
        popupInfo.addPopup(pPlayer.getID())
        

def Image(pPlayer, argsList):
    self, iX, iY, iRadius = argsList
    iTeam = pPlayer.getTeam()
    
    # Build Notification
    pNotification = SatelliteImageNotification((iTeam, iX, iY, iRadius, "Prior to landing you surveyed your landing area via imaging probe..."))
    # Do notification
    GameEvents.addNotification(pPlayer, pNotification)
    
    

class SatelliteImageNotification(GameEvents.Notification):
    def __init__(self, notificationData):
        ' Initilize base class '
        self.parent = GameEvents.Notification
        self.parent.__init__(self, notificationData)
    
    # Notify Player
    def notify(self, pPlayer, nextNotification):
        iTeam = self.NotificationData[0]
        iX = self.NotificationData[1]
        iY = self.NotificationData[2]
        iRadius = self.NotificationData[3]
        
        pPlot = gc.getMap().plot(iX, iY)
        CyCamera().JustLookAtPlot(pPlot)
        popup = PyPopup.PyPopup(5021, EventContextTypes.EVENTCONTEXT_ALL)
        popup.setUserData((self, pPlayer.getID(), nextNotification))
        popup.setHeaderString("Satellite Imaging")
        message = self.NotificationData[4]
        popup.setBodyString( message )
        popup.launch(True, PopupStates.POPUPSTATE_QUEUED)
        
        for x in range (-iRadius, iRadius+1):
            for y in range (-iRadius, iRadius+1):
                pPlot = gc.getMap().plot(iX+x, iY+y)
                if(not pPlot.isNone()):
                    pPlot.setRevealed(iTeam, True, False, iTeam)
    
    # No processing, just go to next
    def apply(self, playerID, popupUserData, popupReturn):
        # Assert playerID == popupUserData[1]
        
        self.parent.notify(self, pPlayer, nextEvent)
    