## Colonize the Moon Mod Project
## Changes copyright Shin 2005
## (if any portion of this copyright should be found to be void, the remainder shall remain in full effect)
##
## TechEdge
#
#1+  TechA   UNITCOMBAT_Type PROMOTION_Type  Precedence code string
#    TechA  ...
#
# --Shin
# (aka. Belizan)


from CvPythonExtensions import *
from types import *
import random
import cPickle

import Config

gc = CyGlobalContext()



def getTriggersFor(pTeam):
    promoDictionary = {}
    category = {}
    techTriggerDict = Config.getTechTriggerDict()
    
    for iTech in range(gc.getNumTechInfos()):
        if(pTeam.isHasTech(iTech)):
            techKey = gc.getTechInfo(iTech).getType()
            if(techTriggerDict.has_key(techKey)):
                trigs = techTriggerDict[techKey]
                for trig in trigs:
                    iCat = trig.getCategory()
                    if(category.has_key(iCat)):
                        category[iCat].append(trig)
                    else:
                        category[iCat] = []
                        category[iCat].append(trig)
                
    return category
        
def defineContext(pUnit):
    contextDict = {}
    
    try:
        contextDict["unitdomain"] = gc.getDomainInfo(pUnit.getDomainType()).getType()
    except:
        contextDict["unitdomain"] = "NONE"
        
    try:
        contextDict["unittype"] = gc.getUnitInfo(pUnit.getUnitType()).getType()
    except:
        contextDict["unittype"] = "NONE"
        
    try:
        contextDict["unitclass"] = gc.getUnitClassInfo(pUnit.getUnitClassType()).getType()
    except:
        contextDict["unitclass"] = "NONE"
        
    try:
        contextDict["combatclass"] = gc.getUnitCombatInfo(pUnit.getUnitCombatType()).getType()
    except:
        contextDict["combatclass"] = "NONE"
        
    contextDict["player"] = gc.getPlayer(pUnit.getOwner())
    contextDict["team"] = gc.getPlayer(pUnit.getOwner()).getTeam()
    
    return contextDict
    
    
    
class TechnologyTriggeredPromotion:
    def __init__(self, ePromotion, sApplies, sPrecedence, iCategory=1):
        self.Category = iCategory
        #self.ApplicativeCode = compile(sApplies, '', 'eval')
        #self.PrecedenceCode = compile(sPrecedence, '', 'eval')
        self.ApplicativeCode = sApplies
        self.PrecedenceCode = sPrecedence
        self.Promotion = ePromotion
        
    def getCategory(self):
        return self.Category
    
    def testApplicable(self, pUnit):
        context = defineContext(pUnit)
        #gc = CyGlobalContext()
        return eval(self.ApplicativeCode, context)
    
    def getPrecedence(self, pUnit):
        context = defineContext(pUnit)
        #gc = CyGlobalContext()
        return eval(self.PrecedenceCode, context)
        
    def applyPromotion(self, pUnit):
        pUnit.setHasPromotion(gc.getInfoTypeForString(self.Promotion), True)
        
    