## Colonize the Moon Mod Project
## Changes copyright Shin 2006
## (if any portion of this copyright should be found to be void, the remainder shall remain in full effect)
##
## TerrainAttrition
#
# --Shin
# (aka. Belizan)

from CvPythonExtensions import *
from types import *
import random
import UnitUtils
import DebugUtils
import Config

gc = CyGlobalContext()


def testAttrition(pUnit):
    pPlot = pUnit.plot()
    dTerrainAttrition = Config.getTerrainAttritionDict()
    eTerrain = gc.getTerrainInfo(pPlot.getTerrainType()).getType()
    dice = gc.getGame().getSorenRand()
    
    message = "Terrain: %s" %(eTerrain)
    #CyInterface().addMessage(pUnit.getOwner(),True,len(message),message,'',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(7),0,0,True,True)
        
    if(dTerrainAttrition.has_key(eTerrain)):
        message = "Terrain Attr. Functions Found"
        #CyInterface().addMessage(pUnit.getOwner(),True,len(message),message,'',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(7),0,0,True,True)
    
        sTestClosure, sEffectClosure = dTerrainAttrition[eTerrain]
        context = UnitUtils.defineUnitContext(pUnit)
        context = defineTerrainContext(pPlot, context)
        context = defineUnitTerrainContext(pPlot, pUnit, context)
        context["dice"] = dice
        
        DebugUtils.debugStr("Eval: %s" %(str(eval(sTestClosure, context))))
    
        if(eval(sTestClosure, context)):
            iDamage = eval(sEffectClosure, context)
            DebugUtils.debugStr("Attrition: %d (+%d)" %(iDamage, pUnit.getDamage()))
            applyAttritionDamage(pUnit, iDamage)
            
            
def applyAttritionDamage(pUnit, iDamage):
    iCurDamage = pUnit.getDamage() + iDamage
    if(iCurDamage > 100):
        UnitUtils.setUnitDictionaryValue(pUnit, "attritionDeath", True)
    
    pUnit.setDamage(iCurDamage, True)
    

def defineTerrainContext(pPlot, dContext = {}):
    # Just being silly with these
    dContext["isflatlands"] = pPlot.isFlatlands()
    dContext["ishills"] = pPlot.isHills()
    dContext["isroute"] = pPlot.isRoute()
    
    try:
        dContext["bonustype"] = gc.getBonusInfo(pPlot.getBonusType(-1)).getType()
    except:
        dContext["bonustype"] = "NONE"
    
    try:
        dContext["improvement"] = gc.getImprovementInfo(pPlot.getImprovement()).getType()
    except:
        dContext["improvement"] = "NONE"
        
    return dContext


def defineUnitTerrainContext(pPlot, pUnit, dContext = {}):
    try:
        iPlotTeam = gc.getPlayer(pPlot.getOwner()).getTeam()
    except:
        iPlotTeam = -1
    iUnitTeam = gc.getPlayer(pUnit.getOwner()).getTeam()
    dContext["ishometerritory"] = (pPlot.getOwner() == pUnit.getOwner())
    dContext["isfriendlyterritory"] = (iPlotTeam == iUnitTeam)
    dContext["isopenterritory"] = ((not gc.getTeam(iUnitTeam).isAtWar(iPlotTeam)) and (pPlot.getOwner() != -1))
    dContext["iswarterritory"] = gc.getTeam(iUnitTeam).isAtWar(iPlotTeam)
    iWS = gc.getMap().getWorldSize()
    iMax = 4*iWS + 8
    dContext["worldsize"] = iWS
    iDistance = getDistanceToHomeTerritory(pUnit, iMax)
    dContext["distancefromhome"] = iDistance
    
    iDistCategory = min((iDistance/(iWS + 2)), 4) + 1
    dContext["distancecategory"] = iDistCategory
    
    DebugUtils.debugStr("Distance: %d/%d(%d)" %(iDistance, iMax, iDistCategory))
    
    return dContext
    
# as the Crow Flies (atm)
# doesn't take into consideration allies (team mates)
def getDistanceToHomeTerritory(pUnit, iMax):
    iDist = 1
    iOrigX = pUnit.getX()
    iOrigY = pUnit.getY()
    map = gc.getMap()
    iOwner = pUnit.getOwner()
    if(pUnit.plot().getOwner() == iOwner):
        return 0
    while True:
        for iDelta in range(iDist):
            iX = iOrigX + iDelta
            iY = iOrigY + (iDist - iDelta)
            pPlot = map.plot(iX, iY)
            # These isNone tests are unnecessary
            if(not pPlot.isNone()):
                if(pPlot.isOwned()):
                    if(map.plot(iX, iY).getOwner() == iOwner):
                        return iDist
            
            iX = iOrigX + iDelta
            iY = iOrigY - (iDist - iDelta)
            pPlot = map.plot(iX, iY)
            if(not pPlot.isNone()):
                if(pPlot.isOwned()):
                    if(map.plot(iX, iY).getOwner() == iOwner):
                        return iDist
            
            iX = iOrigX - iDelta
            iY = iOrigY + (iDist - iDelta)
            pPlot = map.plot(iX, iY)
            if(not pPlot.isNone()):
                if(pPlot.isOwned()):
                    if(map.plot(iX, iY).getOwner() == iOwner):
                        return iDist
            
            iX = iOrigX - iDelta
            iY = iOrigY - (iDist - iDelta)
            pPlot = map.plot(iX, iY)
            if(not pPlot.isNone()):
                if(pPlot.isOwned()):
                    if(map.plot(iX, iY).getOwner() == iOwner):
                        return iDist
            
        iDist = iDist + 1
        if iDist == iMax:
            return iDist
    