## Colonize the Moon Mod Project
## Changes copyright Shin 2005
## (if any portion of this copyright should be found to be void, the remainder shall remain in full effect)
##
## UnitUtils
#
# --Shin
# (aka. Belizan)

from CvPythonExtensions import *
from types import *
import random
import string
import cPickle
import Config

gc = CyGlobalContext()

def initUnitDictionary(pUnit):
    unitDict = {}
    pUnit.setScriptData(cPickle.dumps(unitDict))
    
def getUnitDictionary(pUnit):
    if(pUnit.getScriptData() != ""):
        unitDict = cPickle.loads(pUnit.getScriptData())
    else:
        unitDict = {}
    return unitDict
    
def setUnitDictionary(pUnit, unitDict):
    pUnit.setScriptData(cPickle.dumps(unitDict))
    
def getUnitDictionaryValue(pUnit, sValKey):
    unitDict = getUnitDictionary(pUnit)
    if(unitDict.has_key(sValKey)):
        return unitDict[sValKey]
    else:
        return 0
    
def setUnitDictionaryValue(pUnit, sValKey, oVal):
    unitDict = getUnitDictionary(pUnit)
    unitDict[sValKey] = oVal
    setUnitDictionary(pUnit, unitDict)
    
def setLastXY(pUnit, iX = -1, iY = -1):
    if(iX == -1):
        iX = pUnit.getX()
        
    if(iY == -1):
        iY = pUnit.getY()
        
    unitDict = getUnitDictionary(pUnit)
    unitDict["lastX"] = iX
    unitDict["lastY"] = iY
    setUnitDictionary(pUnit, unitDict)
    
def getLastX(pUnit):
    unitDict = getUnitDictionary(pUnit)
    return unitDict["lastX"]
    
def getLastY(pUnit):
    unitDict = getUnitDictionary(pUnit)
    return unitDict["lastY"]
    
def getLastPlot(pUnit):
    unitDict = getUnitDictionary(pUnit)
    return gc.getMap().plot(unitDict["lastX"], unitDict["lastY"])
    
def setUnitKilled(pUnit, bKilled=True):
    unitDict = getUnitDictionary(pUnit)
    unitDict["unitKilled"] = bKilled
    setUnitDictionary(pUnit, unitDict)
    
def getUnitKilled(pUnit):
    unitDict = getUnitDictionary(pUnit)
    if(unitDict.has_key("unitKilled") == 0):
        return False
    else:
        return unitDict["unitKilled"]
    

    
def upgradeUnit(pUnit, iUnitClass):
    gc = CyGlobalContext()
    pPlayer = gc.getPlayer(pUnit.getOwner())
    # Determine unitType (troublesome with unique units for civs)
    #iUnit = gc.getUnitClassInfo(iUnitClass).getDefaultUnitIndex()
    # Changed iUnitClass to be a unit type for the moment
    iUnit = iUnitClass
    
    #unitAIType enum to not enum bugs are driving me nuts
    #newUnit = pPlayer.initUnit(iUnit, pUnit.getX(), pUnit.getY(), pUnit.getUnitAIType())
    newUnit = pPlayer.initUnit(iUnit, pUnit.getX(), pUnit.getY(), UnitAITypes(pUnit.getUnitAIType()))
    newUnit.setExperience(pUnit.getExperience(), pUnit.getExperience())
    if(pUnit.movesLeft() > 0):
        newUnit.setMoves(pUnit.getMoves())
        newUnit.changeMoves(pUnit.getMoves())
    else:
        newUnit.finishMoves()
        
    newUnit.setLevel(pUnit.getLevel())
    for iPromotion in range(gc.getNumPromotionInfos()):
        if(pUnit.isHasPromotion(iPromotion)):
            newUnit.setHasPromotion(iPromotion, True)
    
    newUnit.setPromotionReady(pUnit.isPromotionReady())
    
    newUnit.setDamage(pUnit.getDamage(), False)
    
    unitDict = getUnitDictionary(pUnit)
    setUnitDictionary(newUnit, unitDict)
    
    # Unit Cargo
    if(pUnit.hasCargo()):
        cCargo = []
        #sweep units in plot
        pPlot = pUnit.plot()
        for iUnit in range(pPlot.getNumUnits()):
            pCargoP = pPlot.getUnit(iUnit) 
            if(pCargoP.getTransportUnit().getID() == pUnit.getID()):
                cCargo.append(pCargoP)
                
        for pCargo in cCargo:
            pNewCargo = cloneUnit(pCargo)
            newUnit.doCommand(CommandTypes.COMMAND_LOAD, pNewCargo.getID(), 0)
    
    pUnit.setDamage(100, True)
    #pUnit.kill(True, 0)  #Not sure what the second parameter does :/
    
    return newUnit
    
    
# Clone a unit
def cloneUnit(pUnit, iNewOwner = -1, iX = -1, iY = -1, iNewHealth = -1, eNewType = -1):
    gc = CyGlobalContext()
    pPlayer = gc.getPlayer(iNewOwner)
    if(iNewOwner == -1):
        pPlayer = gc.getPlayer(pUnit.getOwner())
    else:
        pPlayer = gc.getPlayer(iNewOwner)
    
    if(iX == -1):
        iX = pUnit.getX()
    if(iY == -1):
        iY = pUnit.getY()
    
    if(eNewType == -1):
        newUnit = pPlayer.initUnit(pUnit.getUnitType(), iX, iY, UnitAITypes(pUnit.getUnitAIType()))
    else:
        newUnit = pPlayer.initUnit(gc.getInfoTypeForString(eNewType), iX, iY, UnitAITypes(pUnit.getUnitAIType()))
        
    newUnit.setExperience(pUnit.getExperience(), pUnit.getExperience())
    if(pUnit.movesLeft() > 0):
        #newUnit.setMoves(pUnit.movesLeft())
        #iX = newUnit.getX()
        #iY = newUnit.getY()
        #message = "Change Moves? (%d, %d(%d)| %d, %d(%d))" %(newUnit.getMoves(), newUnit.movesLeft(), newUnit.baseMoves(), pUnit.getMoves(), pUnit.movesLeft(), pUnit.baseMoves())
        #CyInterface().addMessage(newUnit.getOwner(),True,len(message),message,'AS2D_BOMBARDED',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(8),iX,iY,True,True)
        #newUnit.changeMoves(pUnit.movesLeft())
        #iX = newUnit.getX()
        #iY = newUnit.getY()
        #message = "Change Moves? (%d, %d(%d)| %d, %d(%d))" %(newUnit.getMoves(), newUnit.movesLeft(), newUnit.baseMoves(), pUnit.getMoves(), pUnit.movesLeft(), pUnit.baseMoves())
        #CyInterface().addMessage(newUnit.getOwner(),True,len(message),message,'AS2D_BOMBARDED',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(8),iX,iY,True,True)
        newUnit.setMoves(pUnit.getMoves())
        #iX = newUnit.getX()
        #iY = newUnit.getY()
        #message = "Change Moves? (%d, %d(%d)| %d, %d(%d))" %(newUnit.getMoves(), newUnit.movesLeft(), newUnit.baseMoves(), pUnit.getMoves(), pUnit.movesLeft(), pUnit.baseMoves())
        #CyInterface().addMessage(newUnit.getOwner(),True,len(message),message,'AS2D_BOMBARDED',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(8),iX,iY,True,True)
        newUnit.changeMoves(pUnit.getMoves())
        #iX = newUnit.getX()
        #iY = newUnit.getY()
        #message = "Change Moves? (%d, %d(%d)| %d, %d(%d))" %(newUnit.getMoves(), newUnit.movesLeft(), newUnit.baseMoves(), pUnit.getMoves(), pUnit.movesLeft(), pUnit.baseMoves())
        #CyInterface().addMessage(newUnit.getOwner(),True,len(message),message,'AS2D_BOMBARDED',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(8),iX,iY,True,True)
    else:
        newUnit.finishMoves()
        #iX = newUnit.getX()
        #iY = newUnit.getY()
        #message = "Finished MOVE?!? (%s, %s)" %(str(newUnit.getMoves()), str(newUnit.movesLeft()))
        #CyInterface().addMessage(newUnit.getOwner(),True,len(message),message,'AS2D_BOMBARDED',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(8),iX,iY,True,True)
    
        
    newUnit.setLevel(pUnit.getLevel())
    for iPromotion in range(gc.getNumPromotionInfos()):
        if(pUnit.isHasPromotion(iPromotion)):
            newUnit.setHasPromotion(iPromotion, True)
            
    newUnit.setPromotionReady(pUnit.isPromotionReady())
    if(iNewHealth == -1):
        newUnit.setDamage(pUnit.getDamage(), False)
    else:
        newUnit.setDamage(iNewHealth, False)
    
    unitDict = getUnitDictionary(pUnit)
    setUnitDictionary(newUnit, unitDict)
    
    # Unit Cargo
    if(pUnit.hasCargo()):
        cCargo = []
        #sweep units in plot
        pPlot = pUnit.plot()
        for iUnit in range(pPlot.getNumUnits()):
            pCargoP = pPlot.getUnit(iUnit) 
            if(pCargoP.getTransportUnit().getID() == pUnit.getID()):
                cCargo.append(pCargoP)
                
        for pCargo in cCargo:
            cloneUnit(pCargo)
            
    return newUnit
    
    
# AI Resets move orders during turn
def AddMoveTo(pUnit, iX, iY):
    pGroup = pUnit.getGroup()
    pGroup.pushMoveToMission(iX, iY)
    setUnitDictionaryValue(pUnit, "StandingOrders", "pGroup.pushMoveToMission(%d, %d)" %(iX, iY))
    setUnitDictionaryValue(pUnit, "ClearStandingOrders", "pGroup.getPathEndTurnPlot().at(%d, %d)" %(iX, iY))

def ResetUnitOrders(pPlayer):
    pYPlayer = PyPlayer(pPlayer)
    for pUnit in pYPlayer.getUnitList():
        sOrders = getUnitDictionaryValue(pUnit, "StandingOrders")
        if(sOrders != 0):
            pGroup = pUnit.getGroup()
            eval(sOrders)    
            sClearEval = getUnitDictionaryValue(pUnit, "ClearStandingOrders")
            if(eval(sClearEval)):
                removeUnitDictionaryValue(pUnit, "StandingOrder")
                removeUnitDictionaryValue(pUnit, "ClearStandingOrders")
                
                

def defineUnitContext(pUnit):
    contextDict = {}
    
    try:
        contextDict["unitdomain"] = gc.getDomainInfo(pUnit.getDomainType()).getType()
    except:
        contextDict["unitdomain"] = "NONE"
        
    try:
        contextDict["unittype"] = gc.getUnitInfo(pUnit.getUnitType()).getType()
    except:
        contextDict["unittype"] = "NONE"
        
    try:
        contextDict["unitclass"] = gc.getUnitClassInfo(pUnit.getUnitClassType()).getType()
    except:
        contextDict["unitclass"] = "NONE"
        
    try:
        contextDict["combatclass"] = gc.getUnitCombatInfo(pUnit.getUnitCombatType()).getType()
    except:
        contextDict["combatclass"] = "NONE"
        
    contextDict["player"] = gc.getPlayer(pUnit.getOwner())
    contextDict["team"] = gc.getPlayer(pUnit.getOwner()).getTeam()
    
    return contextDict
    

# Capture Functions
def checkUnitCaptures(pWinner, pLoser):
    dUnitCaptures = Config.getUnitCapturesDict()
    eWinner = gc.getUnitInfo(pWinner.getUnitType()).getType()
    bCaptured = False
    if(dUnitCaptures.has_key(eWinner)):
        context = defineUnitContext(pLoser)
        dice = gc.getGame().getSorenRand()
        context["dice"] = dice
        bCaptured = eval(dUnitCaptures[eWinner][0], context)
        if(bCaptured):
            context = defineUnitContext(pLoser)
            cloneUnit(pLoser, pWinner.getOwner(), pWinner.getX(), pWinner.getY(), 50, eval(dUnitCaptures[eLoser][1], context))
            
    return bCaptured

# Obsolete
def testCaptures(pWinner, pLoser):
    dUnitCaptures = Config.getUnitCapturesDict()
    eWinner = gc.getUnitInfo(pWinner.getUnitType()).getType()
    if(dUnitCaptures.has_key(eWinner)):
        context = defineUnitContext(pLoser)
        dice = gc.getGame().getSorenRand()
        context["dice"] = dice
        return eval(dUnitCaptures[eWinner][0], context)
    else:
        return False

# Obsolete
def captureUnit(pWinner, pLoser):
    dUnitCaptures = Config.getUnitCapturesDict()
    eWinner = gc.getUnitInfo(pWinner.getUnitType()).getType()
    if(dUnitCaptures.has_key(eWinner)):
        context = defineUnitContext(pLoser)
        dice = gc.getGame().getSorenRand()
        context["dice"] = dice
        cloneUnit(pLoser, pWinner.getOwner(), pWinner.getX(), pWinner.getY(), 50, eval(dUnitCaptures[eLoser][1], context))
    

# Surrender Functions
def checkUnitSurrenders(pWinner, pLoser):
    dUnitSurrenders = Config.getUnitSurrendersDict()
    eLoser = getUnitTypeString(pLoser)
    bSurrendered = False
    if(dUnitSurrenders.has_key(eLoser)):
        context = defineUnitContext(pWinner)
        dice = gc.getGame().getSorenRand()
        context["dice"] = dice
        bSurrendered = eval(dUnitSurrenders[eLoser][0], context)
        if(bSurrendered):
            context = defineUnitContext(pWinner)
            cloneUnit(pLoser, pWinner.getOwner(), pWinner.getX(), pWinner.getY(), 50, eval(dUnitSurrenders[eLoser][1], context))
    
    return bSurrendered

# Obsolete
def testSurrenders(pWinner, pLoser):
    dUnitSurrenders = Config.getUnitSurrendersDict()
    eLoser = getUnitTypeString(pLoser)
    if(dUnitSurrenders.has_key(eLoser)):
        context = defineUnitContext(pWinner)
        dice = gc.getGame().getSorenRand()
        context["dice"] = dice
        return eval(dUnitSurrenders[eLoser][0], context)
    else:
        return False

# Obsolete
def surrenderUnit(pWinner, pLoser):
    dUnitSurrenders = Config.getUnitSurrendersDict()
    eLoser = getUnitTypeString(pLoser)
    if(dUnitSurrenders.has_key(eLoser)):
        context = defineUnitContext(pWinner)
        dice = gc.getGame().getSorenRand()
        context["dice"] = dice
        cloneUnit(pLoser, pWinner.getOwner(), pWinner.getX(), pWinner.getY(), 50, eval(dUnitSurrenders[eLoser][1], context))
    
    
def getUnitTypeString(pUnit):
    return gc.getUnitInfo(pUnit.getUnitType()).getType()    
    
    
def getTagEncodedType(iUnit):
    eUnit = gc.getUnitInfo(iUnit).getType()
    iDX = string.rindex(eUnit, '_') + 1
    eUnit = eUnit[iDX:]
    if (eUnit in Config.TagEncodings):
        return eUnit
    else:
        return "NONE"
    

# Currently assumes iTech is an untagged tech
def isSuchTaggedUnit(iUnit, lTags):
    eUnit = gc.getUnitInfo(iUnit).getType()
    for eTag in lTags:
        sType = eUnit + eTag
        if(gc.getInfoTypeForString(sType) != -1):
            return True
    return False
    
def getAllTaggedBuildings(iBuilding):
    lTags = []
    sTagBase = getTagBaseForBuilding(iBuilding)
    

def getTagBaseForBuilding(iBuilding):
    return 